// ContainEx.h : Declaration of the CContainEx

#ifndef __CONTAINEX_H_
#define __CONTAINEX_H_

#include "resource.h"       // main symbols
#include <atlctl.h>
//#include "hostex.h"


/////////////////////////////////////////////////////////////////////////////
// CContainEx
class ATL_NO_VTABLE CContainEx : 
	public CComObjectRootEx<CComSingleThreadModel>,
	public IContainEx,
	public CComControl<CContainEx>,
	public IPersistStreamInitImpl<CContainEx>,
	public IOleControlImpl<CContainEx>,
	public IOleObjectImpl<CContainEx>,
	public IOleInPlaceActiveObjectImpl<CContainEx>,
	public IViewObjectExImpl<CContainEx>,
	public IOleInPlaceObjectWindowlessImpl<CContainEx>,
	public IPersistStorageImpl<CContainEx>,
	public ISpecifyPropertyPagesImpl<CContainEx>,
	public IQuickActivateImpl<CContainEx>,
	public IDataObjectImpl<CContainEx>,
	public IProvideClassInfo2Impl<&CLSID_ContainEx, NULL, &LIBID_CONT2Lib>,
	public CComCoClass<CContainEx, &CLSID_ContainEx>
{
public:
	CContainEx()
	{
		m_bWindowOnly = TRUE;
	}

DECLARE_REGISTRY_RESOURCEID(IDR_CONTAINEX)
DECLARE_NOT_AGGREGATABLE(CContainEx)

DECLARE_PROTECT_FINAL_CONSTRUCT()

BEGIN_COM_MAP(CContainEx)
	COM_INTERFACE_ENTRY(IContainEx)
	COM_INTERFACE_ENTRY(IViewObjectEx)
	COM_INTERFACE_ENTRY(IViewObject2)
	COM_INTERFACE_ENTRY(IViewObject)
	COM_INTERFACE_ENTRY(IOleInPlaceObjectWindowless)
	COM_INTERFACE_ENTRY(IOleInPlaceObject)
	COM_INTERFACE_ENTRY2(IOleWindow, IOleInPlaceObjectWindowless)
	COM_INTERFACE_ENTRY(IOleInPlaceActiveObject)
	COM_INTERFACE_ENTRY(IOleControl)
	COM_INTERFACE_ENTRY(IOleObject)
	COM_INTERFACE_ENTRY(IPersistStreamInit)
	COM_INTERFACE_ENTRY2(IPersist, IPersistStreamInit)
	COM_INTERFACE_ENTRY(ISpecifyPropertyPages)
	COM_INTERFACE_ENTRY(IQuickActivate)
	COM_INTERFACE_ENTRY(IPersistStorage)
	COM_INTERFACE_ENTRY(IDataObject)
	COM_INTERFACE_ENTRY(IProvideClassInfo)
	COM_INTERFACE_ENTRY(IProvideClassInfo2)
END_COM_MAP()

BEGIN_PROP_MAP(CContainEx)
	PROP_DATA_ENTRY("_cx", m_sizeExtent.cx, VT_UI4)
	PROP_DATA_ENTRY("_cy", m_sizeExtent.cy, VT_UI4)
	// Example entries
	// PROP_ENTRY("Property Description", dispid, clsid)
	// PROP_PAGE(CLSID_StockColorPage)
END_PROP_MAP()

BEGIN_MSG_MAP(CContainEx)
	MESSAGE_HANDLER(WM_CREATE, OnCreate)
	CHAIN_MSG_MAP(CComControl<CContainEx>)
	DEFAULT_REFLECTION_HANDLER()
END_MSG_MAP()
// Handler prototypes:
//  LRESULT MessageHandler(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);
//  LRESULT CommandHandler(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled);
//  LRESULT NotifyHandler(int idCtrl, LPNMHDR pnmh, BOOL& bHandled);



// IViewObjectEx
	DECLARE_VIEW_STATUS(VIEWSTATUS_SOLIDBKGND | VIEWSTATUS_OPAQUE)

// IContainEx
public:
	HRESULT OnDraw(ATL_DRAWINFO& di)
	{
		RECT& rc = *(RECT*)di.prcBounds;
		return S_OK;
	}
	LRESULT OnCreate(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
	{
		ATLASSERT(m_hWnd);
		USES_CONVERSION;
//		AtlAxCreateControl2(T2COLE("Contain.CTool"), m_hWnd, NULL, NULL);
		return 0;
	}
};

#endif //__CONTAINEX_H_
